#ifndef __MESHTREE_H
#define __MESHTREE_H

#ifdef HAVE_CONFIG_H
#include<yafray_config.h>
#endif

#include <yafray/core/extern/triangle.h>
#include <yafray/core/extern/geometree.h>
#include<vector>

__BEGIN_YAFRAY

typedef pureBspTree_t<std::vector<triangle_t*> > tnode_t;

// tree=buildTriangleTree(ltri,face_calc_bound(*ltri),4);

extern PFLOAT mt_foo1,mt_foo2;

void * buildTriangleTree(std::vector<triangle_t*> *v,
		const bound_t &bound,unsigned int dtol=1,unsigned int depth=1,unsigned int lostd=0,
		PFLOAT &avgdepth=mt_foo1, PFLOAT &avgsize=mt_foo2);

__END_YAFRAY

#endif
