#ifndef __DRAW_H
#define __DRAW_H

class painter_t
{
	public:
		painter_t();
		~painter_t();

		void init(int w, int h);
		void run();
		void update();
		void darken();
		void display();
		void idle() {if(dowork) dowork(arg);};
		void special(int key, int x, int y);
		
		void setWork(void (*dw)(void *), void *a);
		bool wantFinish()const {return wannafinish;};
		
		void set(int x, int y, unsigned char R, unsigned char G, unsigned char B)
		{
			int off = (y * width + x) * 3;
			image[off] = R;
			image[off + 1] = G;
			image[off + 2] = B;
		}
	
		static painter_t & it();
	protected:
		int width, height;
		unsigned char * image;
		int glutWindow;

		void *arg;
		void (*dowork)(void *);
		bool wannafinish;
};

#endif
