#include <yafray/core/extern/scene.h>
#include <yafray/core/extern/render.h>
#include <yafray/fry/draw.h>
#include <yafray/fry/manager.h>
#include <iostream>

using namespace std;

void render(void *it)
{
	renderManager_t * manager = (renderManager_t *) it;
	if(!manager->work())
	{
		if(painter_t::it().wantFinish())
		{
			painter_t::it().setWork(NULL, NULL);
			delete _td(manager);
		}
		else
		{
			manager->nextPass();
			painter_t::it().darken();
		}
	}
	/*
	{
		painter_t::it().setWork(NULL, NULL);
		delete _td(manager);
	}
	*/
}

int main(int argc, char **argv)
{
	painter_t::it().init(640,480);

	for(int y=0;y<480;++y)
		for(int x=0;x<640;++x)
			painter_t::it().set(x,y,220 - x/3, 0 , 240 - y/2);

	painter_t::it().setWork(render, _tn(new renderManager_t(640,480)));
	painter_t::it().run();

	return 0;
}
