#ifndef __MANAGER_H
#define __MANAGER_H

#include <yafray/core/extern/render.h>
#include <yafray/core/extern/output.h>


class renderManager_t : public yafray::colorOutput_t
{
	public:
		renderManager_t(int w, int h);
		virtual ~renderManager_t() {};

		bool work();
		void nextPass() {state = 0;};

		virtual bool putPixel(int x, int y,const yafray::color_t &c, 
				yafray::CFLOAT alpha=0,yafray::PFLOAT depth=0);
		virtual void flush();
		
	protected:
		yafray::scene_t scene;
		yafray::veach_t renderer;
		int state;
};

#endif
